//AnnulerDefinitions_501f.js
// 16.05.15 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Annuler des styles GREP, etc.

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

if (app.documents.length == 0) {
	alert ("Il faut ouvrir un document InDesign.", "Attention");
	exit();
}

// une rfrence au document au premier plan
var curDoc = app.documents[0];

// mmoriser le verrouillage des calques et l'annuler (si ncessaire)
var allLayers = curDoc.layers;
var nLayers = allLayers.length;
var layerLocks = new Array ();
for (var i=0; i<nLayers; i++) {
	if (allLayers[i].locked == true) {
		allLayers[i].locked = false;
		layerLocks.push(true);
	}
	else {
		layerLocks.push(false);
	}
}

// dverrouiller les blocs
curDoc.pageItems.everyItem().locked = false;

// les styles de paragraphe et de caractres "[Aucun]"
try {
	var noParaStyle = curDoc.paragraphStyles[0];
	var noCharStyle = curDoc.characterStyles[0];
}
catch (e) {
}

// les styles de paragraphes...
var allParaStyles = curDoc.allParagraphStyles;
// ... et leur nombre
var nParaStyles = allParaStyles.length;
// les styles de caractres...
var allCharStyles = curDoc.allCharacterStyles;
// ... et leur nombre
var nCharStyles = allCharStyles.length;

// une nuance temporaire
var tmpCol = curDoc.swatches.itemByName("tmpColor");
if (!tmpCol.isValid) {
	var tmpCol = curDoc.colors.add();
	tmpCol.name = "tmpColor";
}

// restaurer les dfinitions GREP
app.findGrepPreferences = app.changeGrepPreferences = null;
// inclure les pages gabarit
app.findChangeGrepOptions.includeMasterPages = true;
// restaurer les dfinitions texte
app.findTextPreferences = app.changeTextPreferences = null;
// inclure les pages gabarit
app.findChangeTextOptions.includeMasterPages = true;

// appliquer les styles de caractres aux styles GREP
for (p=2; p<nParaStyles; p++) {
	var allGrepStyles = allParaStyles[p].nestedGrepStyles;
	var nGrepStyles   = allGrepStyles.length;
	for (n=0; n<nGrepStyles; n++) {
		var curGrep = allGrepStyles[n].grepExpression;
		var curParaStyle  = allParaStyles[p];
		var curCharStyle  = allGrepStyles[n].appliedCharacterStyle;
		var curGrepChange = NothingEnum.nothing;
		app.findGrepPreferences.appliedParagraphStyle = curParaStyle;
		app.findGrepPreferences.appliedCharacterStyle = null;
		app.changeGrepPreferences.appliedCharacterStyle = curCharStyle;
		app.findGrepPreferences.findWhat = curGrep;
		app.changeGrepPreferences.changeTo = "";
		try {
			curDoc.changeGrep();
		}
		catch (e) {
		}
	}
}

// convertir les numrotations et les numrations en texte
var allStories = curDoc.stories;
var nStories   = allStories.length;
for (var s=0; s<nStories; s++) {
	try {
		allStories[s].paragraphs.everyItem().convertBulletsAndNumberingToText();
	}
	catch (e) {
	}
	// traiter galement les tableaux
	try {
		allStories[s].tables.everyItem().cells.everyItem().texts[0].convertBulletsAndNumberingToText();
	}
	catch (e) {
	}
}

// appliquer les styles de caractres au formats imbriqus
for (var c=1; c<nCharStyles; c++) {
	var savedColor = allCharStyles[c].underlineGapColor;
	var finds = undefined;
	var findsLength = 0;
	do {
		if (finds) {findsLength = finds.length}
		allCharStyles[c].underlineGapColor = tmpCol;
		app.findTextPreferences = null;
		app.findTextPreferences.underlineGapColor = tmpCol;
		app.changeTextPreferences.appliedCharacterStyle = allCharStyles[c];
		finds = curDoc.changeText();
	} while (findsLength != finds.length);
	allCharStyles[c].underlineGapColor = savedColor;
}
try {
	tmpCol.remove();
}
catch (e) {
}

// supprimer les styles GREP, les numrations, les numrotatiosn les foramts imbriqus
for (p=2; p<nParaStyles; p++) {
	var allGrepStyles = allParaStyles[p].nestedGrepStyles;
	var nGrepStyles   = allGrepStyles.length;
	for (s=nGrepStyles-1; s>-1; s--) {
		try {
			allParaStyles[p].nestedGrepStyles[s].remove();
		}
		catch (e) {
		}
	}
	try {
		allParaStyles[p].bulletsAndNumberingListType = 1280601711;
	}
	catch (e) {
	}
	var allStyles = allParaStyles[p].nestedStyles;
	var nStyles   = allStyles.length;
	for (s=nStyles-1; s>-1; s--) {
		try {
			allParaStyles[p].nestedStyles[s].remove();
		}
		catch (e) {
		}
	}
}

// restaurer les dfinitions GREP
app.findGrepPreferences = app.changeGrepPreferences = null;
// restaurer les dfinitions texte
app.findTextPreferences = app.changeTextPreferences = null;

// restaurer le verrouillage des calques (si ncessaire)
for (var i=0; i<(nLayers); i++) {
	allLayers[i].locked = layerLocks[i];
}

// informer l'utilisateur
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Termin.");
dlog.show();
$.sleep(999);
dlog.close();